<?xml version="1.0" encoding="UTF-8"?>
<!--
/**
 * UCMExporter
 * @author Ali Echihabi
 *
 * (C) Copyright 2003 Use Case Maps User Group
 * www.usecasemaps.org
 */
 
 
 This XSL sheet transforms the XML file generated by
 UCMNav to another XML file that respects the UCMExporterXML.dtd
 The transformation rearranges the input XML and also synthesizes
 new pieces of data such as:
 	-	The objects(component name + role) participating in the
 		scenario
 	-	The messages that have to be added to express correct parallel
 		behaviour (leaving the parallel blocks and entering a new component)
 	-	The messages that have to be added to show the change of components		
 The result of this transformation will act as an intermediary
 for further -hopefully simpler- transformations to XMI, MSC, etc...
 
-->
<!-- start of xsl sheet -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:template match="scenarios">	
		<!-- echo the same element -->	
		<xsl:call-template name="echoElement"/>
		 	
	</xsl:template>

	<xsl:template match="group">	
		<!-- echo the same element -->	
		<xsl:call-template name="echoElement"/>
		
		group:
		<xsl:value-of select="@name"/>
		<!-- call the template for each scenario -->
	</xsl:template>


	<xsl:template name="scenarioTemplate">
		SOME STUFF FOR SCENARIO

	</xsl:template>

	<xsl:template match="scenario">	

		<!-- echo the same element -->	
		<xsl:call-template name="echoElement">
			<xsl:with-param name="nextTemplate" select="'scenarioTemplate'"/>
		</xsl:call-template>	
	
	scenario:
		<xsl:value-of select="@name"/>

	</xsl:template>

<!--
  Finds all instances that participate in the current scenario.
  Each unique pair of (component-name, role-name) of the scenario's <do> elements
  defines an instance.
  The template inserts then <instance> elements after the current scenario element.
  
-->
	<xsl:template name="generateScenarioInstances">	
		<xsl:text> &lt; !-- scenarios go here --&gt;</xsl:text>
	</xsl:template>
	
	
<!--
 This template echoes the current element with all its
 attributes.
-->
	<xsl:template name="echoElement">	
		<xsl:param name="nextMatch"/>
		<xsl:param name="nextTemplate"/>
		
		<xsl:text>&#xa;</xsl:text>	
		<xsl:variable name="elementName">		
			<xsl:value-of select="name()"/>	
		</xsl:variable>	
		<xsl:element name="{$elementName}">		
			<xsl:for-each select="attribute::*">			
				<xsl:variable name="attributeName">				
					<xsl:value-of select="name()"/>			
				</xsl:variable>			
				<xsl:attribute name="{$attributeName}">				
					<xsl:value-of select="."/>			
				</xsl:attribute>		
			</xsl:for-each>		
			<xsl:if test="string-length($nextMatch) = 0">
			</xsl:if>
			
			<xsl:call-template name="{$nextTemplate}"/>
			<xsl:apply-templates select="child::*"/>
						
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
<!-- end of xsl sheet -->