<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:import href = "custom.xsl"/>
<xsl:output method = "text" />
<xsl:strip-space elements = "*" />



<!--
* Name:	scenario
*
* Description:
*
*	This is the matched template for 'scenario' element. 
*
-->
<xsl:template match = "//scenario">
	<xsl:call-template name = "write_document_header" />	


	<xsl:call-template name = "generate_instances" />


	<xsl:call-template name = "write_scenario_header" />


	<!-- apply template for first direct child node -->
	<xsl:apply-templates select = "child::*[1]" >
		<xsl:with-param name = "msgid" select = '1' />
	</xsl:apply-templates>			
	<xsl:text>&#xa;</xsl:text>
	

	<xsl:call-template name = "generate_endinstances" />


	<xsl:call-template name = "write_document_footer" />			
</xsl:template>



<!--
* Name:	par
*
* Description:
*
*	This is the matched template for 'par' element. 
*
-->
<xsl:template match = "par">
<xsl:param name = "msgid" />

    
    
	<!-- print out 'all: par begin;' stmt -->
        <xsl:text>all: par begin</xsl:text>
        <xsl:text>;&#xa;</xsl:text>

	<!-- apply template for first direct child node -->
	<xsl:apply-templates select = "child::*[1]" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:apply-templates>			
</xsl:template>



<!--
* Name:	seq
*
* Description:
*
*	This is the matched template for 'seq' element. 
*
-->
<xsl:template match = "seq">
<xsl:param name = "msgid" />
	<!-- print out 'par;' stmt -->
	<xsl:choose>
	<xsl:when test = "name(ancestor::*[1]) = 'par' and name(preceding-sibling::*[1]) = 'seq'">
	  <xsl:text>par;&#xa;</xsl:text>
	  <xsl:choose>
	  <xsl:when test ="ancestor::node()[2]/do[last()]/@component-name and child::do[1]/@component-name and
	              //ancestor::node()[2]/do[last()]/@component-name != child::do[1]/@component-name ">
	    <xsl:value-of select ="ancestor::node()[2]/do[last()]/@component-name"/>			
					<xsl:text>: out m</xsl:text>
					<xsl:value-of select = "$msgid" />		
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select = "child::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					
					<xsl:value-of select = "child::do[1]/@component-name" />
					<xsl:text>: in m</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="ancestor::node()[2]/do[last()]/@component-name"/>
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- apply template for first direct child node -->
	                 <xsl:apply-templates select = "child::*[1]" >
		           <xsl:with-param name = "msgid" select = "$msgid +1" />
	             </xsl:apply-templates>
	  </xsl:when>
	  
	  <xsl:otherwise>
	   <!-- apply template for first direct child node -->
	   <xsl:apply-templates select = "child::*[1]" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	   </xsl:apply-templates>
      </xsl:otherwise>
      
     </xsl:choose> 			
  </xsl:when>
  
  <xsl:otherwise>
	<!-- apply template for first direct child node -->
	<xsl:apply-templates select = "child::*[1]" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:apply-templates>
 </xsl:otherwise>
 </xsl:choose>
</xsl:template>


<!--
* Name:	condition
*
* Description:
*
*	This is the matched template for 'condition' element.
*   
*   NOTE: Individual 'do' element will print out 'following-sibling'
*   conditions 
*
-->
<xsl:template match = "condition" >
<xsl:param name = "msgid" />
	<!-- skip! apply template for first following node -->
	<xsl:apply-templates select = "following::*[1] " >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:apply-templates>			
</xsl:template>


<!--
* Name:	do
*
* Description:
*
*	This is the matched template for 'do' element. It calls
*   appropriate named template depending on the value of
*   type attribute.
*
-->
<xsl:template match = "do" >
<xsl:param name = "msgid" />
	<!-- call appropriate named template for each diff do element type -->
	<xsl:choose>
		<xsl:when test = "@type = 'Connect_Start'" >
			<xsl:call-template name = "Connect_Start" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Connect_End'" >
			<xsl:call-template name = "Connect_End" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'End_Point'" >
			<xsl:call-template name = "End_Point" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Resp'" >
			<xsl:call-template name = "Resp" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Start'" >
			<xsl:call-template name = "Start" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Timer_Reset'" >
			<xsl:call-template name = "Timer_Reset" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>
		
		<xsl:when test = "@type = 'Timer_Set'" >
			<xsl:call-template name = "Timer_Set" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Time_Out'" >
			<xsl:call-template name = "Timer_Set" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<xsl:when test = "@type = 'Trigger_End'" >
			<xsl:call-template name = "Trigger_End" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>
	</xsl:choose>
</xsl:template>



<!--
* Name:	Connect_Start
*
* Description:
*
*	This is the named template for 'Connect_Start' attribute. 
*
-->
<xsl:template name = "Connect_Start">
<xsl:param name = "msgid" />
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions"  />	

	<!-- print out messages and proc next node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Connect_End
*
* Description:
*
*	This is the named template for 'Connect_End' attribute. 
*
-->
<xsl:template name = "Connect_End">
<xsl:param name = "msgid" />
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions"  />	

	<!-- print out messages and proc next node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	End_Point
*
* Description:
*
*	This is the named template for 'End_Point' attribute. 
*
-->
<xsl:template name = "End_Point">
<xsl:param name = "msgid" />
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions"  />	

	<!-- 
	     apply template for first following node
	     no need to print out msgs, but have to proc 
	     following node bc scenario may have more
		 than one end pt.      
	-->
	<!--
	<xsl:apply-templates select = "following::*[1]" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:apply-templates>
	-->
	<!-- print out messages and proc next node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Resp
*
* Description:
*
*	This is the named template for 'Resp' attribute. 
*
-->
<xsl:template name = "Resp" >
<xsl:param name = "msgid" />
	<!-- print out component name or white spaces -->
	<xsl:call-template name = "write_component_name" />	

	<!-- print out action stmt -->
	<xsl:text>action 'TASK </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>';&#xa;</xsl:text>
	
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Start
*
* Description:
*
*	This is the named template for 'Start' attribute. It
*   generates the first message.
*
-->
<xsl:template name = "Start">
<xsl:param name = "msgid" />
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Timer_Reset
*
* Description:
*
*	This is the named template for 'Timer_Reset' attribute.
*
-->
<xsl:template name = "Timer_Reset">
<xsl:param name = "msgid" />
	<!-- print out component name or white spaces -->
	<xsl:call-template name = "write_component_name" />	

	<!-- print out 'reset' stmt -->
	<xsl:text>reset </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>, </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>;&#xa;</xsl:text>
	
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Timer_Set
*
* Description:
*
*	This is the named template for 'Timer_Set' attribute.
*
-->
<xsl:template name = "Timer_Set">
<xsl:param name = "msgid" />
	<!-- print out component name or white spaces -->
	<xsl:call-template name = "write_component_name" />	

	<!-- print out action stmt -->
	<xsl:text>action TASK '</xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>';&#xa;</xsl:text>
	
	<!-- print out component name or white spaces -->
	<xsl:call-template name = "write_component_name" />	

	<!-- print out 'set' stmt -->
	<xsl:text>set </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>, </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>;&#xa;</xsl:text>
	
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Timeout
*
* Description:
*
*	This is the named template for 'Timeout' attribute.
*
-->
<xsl:template name = "Time_Out">
<xsl:param name = "msgid" />
	<!-- print out component name or white spaces -->
	<xsl:call-template name = "write_component_name" />	

	<!-- print out 'timeout' stmt -->
	<xsl:text>timeout </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>, </xsl:text>
	<xsl:value-of select="@name" />
	<xsl:text>;&#xa;</xsl:text>
	
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	Trigger_End
*
* Description:
*
*	This is the named template for 'Trigger_End' attribute.
*
-->
<xsl:template name = "Trigger_End">
<xsl:param name = "msgid" />
	<!-- print out all 'following-sibling' conditions  -->
	<xsl:call-template name = "write_conditions" />	

	<!-- print out messages and proc next follwing node -->
	<xsl:call-template name = "generate_message" >
		<xsl:with-param name = "msgid" select = "$msgid" />
	</xsl:call-template>			
</xsl:template>



<!--
* Name:	generate_message
*
* Description:
*
*	The template calls 'write_message' if current do element is not:
*   1) last do element of par/seq 
*   2) last do element of scenario
*
-->
<xsl:template name = "generate_message">
<xsl:param name = "msgid" />	
	<xsl:variable name = "hedge" select = "@hyperedge-id" />
	<xsl:choose>
		<!-- if current do is NOT the last do of par/seq -->
		<xsl:when test = "name(ancestor::node()[2]) = 'par' and 
			              parent::seq/do[position() = last()]/@hyperedge-id != $hedge">
			<!-- print out 'in' and 'out' messages -->
			<xsl:call-template name = "write_message" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>

		<!-- if current do is the last do of par/seq -->
		<xsl:when test = "name(ancestor::node()[2]) = 'par' and 
		                  parent::seq/do[position() = last()]/@hyperedge-id  = $hedge">
			<!-- if current do is the last do of last seq of par -->
			<xsl:if test = "ancestor::node()[2]/seq[last()]/do[last()]/@hyperedge-id  = $hedge" >
				<!-- print out 'par end' stmt -->
				<xsl:text>par end; </xsl:text>
				<xsl:text>&#xa;</xsl:text>	
			</xsl:if>
			
			<!-- proc next node -->			
			<xsl:apply-templates select = "following::*[1]" >				
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:apply-templates>			
		</xsl:when>

		<!-- if current do is NOT the last do of doc -->
		<xsl:when test = "name(ancestor::node()[2]) != 'par' and 
		                  //do[position() = last()]/@hyperedge-id != $hedge" >	
			<!-- print out 'in' and 'out' messages -->
			<xsl:call-template name = "write_message" >
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:call-template>			
		</xsl:when>
	</xsl:choose>					
</xsl:template>



<!--
* Name:	generate_endinstances
*
* Description:
*
*	The template recursively counts the number of remaining descendant 'do'
*   elements whose has component-name as the current 'do' element. If the 
*   the number equals to zero, then it prints out 'endinstance' statement.
*
-->
<xsl:template name = "generate_endinstances">
<xsl:param name = "index" select ="1" />
  <xsl:choose>
   
	<xsl:when test = "descendant::do[$index]/@component-name" >
		<!-- count -->
		<xsl:variable name = "componentname" select = "descendant::do[$index]/@component-name" />
		<xsl:if test = "count(descendant::do[position() > $index][@component-name = $componentname]) = 0" >
			<xsl:value-of select="$componentname" /> 
			<xsl:text>: endinstance;&#xa;</xsl:text> 
		</xsl:if>		
	</xsl:when>
	<xsl:otherwise>
	    <xsl:if test ="descendant::do[$index]/@type = 'Start'">
	       <xsl:text>Environment: endinstance;&#xa;</xsl:text>
	    </xsl:if>  
	</xsl:otherwise>    
</xsl:choose>
	

		<!-- process next descendant do element -->
		<xsl:if test = "count(descendant::do) > $index" >
			<xsl:call-template name = "generate_endinstances" >
				<xsl:with-param name = "index"  select = "$index + 1" />
			</xsl:call-template>
		</xsl:if>
</xsl:template>



<!--
* Name:	generate_instances
*
* Description:
*
*	The template recursively counts the number of remaining descendant 'do'
*   elements whose has component-name as the current 'do' element. If the 
*   the number equals to zero, then it prints out 'instance' statement.
*
-->
<xsl:template name = "generate_instances">
<xsl:param name = "index" select ="1" />
<xsl:choose>
   
	<xsl:when test = "descendant::do[$index]/@component-name" >
		<!-- count -->
		<xsl:variable name = "componentname" select = "descendant::do[$index]/@component-name" />
		<xsl:if test = "count(descendant::do[position() > $index][@component-name = $componentname]) = 0" >
			<xsl:value-of select="$componentname" /> 
			<xsl:text>: instance;&#xa;</xsl:text> 
		</xsl:if>		
	</xsl:when>
	<xsl:otherwise>
	    <xsl:if test ="descendant::do[$index]/@type = 'Start'">
	       <xsl:text>Environment: instance;&#xa;</xsl:text>
	    </xsl:if>  
	</xsl:otherwise>    
</xsl:choose>
		<!-- process next descendant do element -->
		<xsl:if test = "count(descendant::do) > $index" >
			<xsl:call-template name = "generate_instances" >
				<xsl:with-param name = "index"  select = "$index + 1" />
			</xsl:call-template>
		</xsl:if>
</xsl:template>



<!--
* Name:	write_component_name
*
* Description:
*
*	The template print out component name of 'do' element
*
-->
<xsl:template name = "write_component_name">
	<xsl:choose>
		<!-- 
			 if current do element is the first child of its parent
			 then print out the value of its component-name attirbute.
		-->		 	
		<xsl:when test = "parent::*/do[position() = 1]/@hyperedge-id = @hyperedge-id">
			<xsl:value-of select = "@component-name" />
			<xsl:text>: </xsl:text>
		</xsl:when>

		<!-- print out whites spaces -->
		<xsl:otherwise>
		   <xsl:choose>
		    <xsl:when test="name(ancestor::node()[2]) ='par' and @type='Resp'">
		        <xsl:value-of select = "@component-name" />
			    <xsl:text>: </xsl:text>
			</xsl:when> 
                    <xsl:when test= "name(following::*[1]) = 'par'">
                         <xsl:value-of select = "@component-name" />
			    <xsl:text>: </xsl:text>
			</xsl:when> 
                    
			
		    <xsl:otherwise>
			  <xsl:call-template name = "write_whitespaces" >
				<xsl:with-param name = "length" select = "string-length(@component-name) + 2" />							
			  </xsl:call-template>			
		    </xsl:otherwise>
	      </xsl:choose>
	    </xsl:otherwise>  	
	</xsl:choose>    
</xsl:template>



<!--
* Name:	write_conditions
*
* Description:
*
*	The template recursively prints out all 'following-sibling'
*   conditions of 'do' element.
*
-->
<xsl:template name = "write_conditions">
<xsl:param name = "index"  select = "1" />
	<!-- check whether the name of 'following-sibling' node is condition -->
	<xsl:if test = "name(following-sibling::*[$index]) = 'condition'" >
		<xsl:call-template name = "write_whitespaces" >
			<xsl:with-param name = "length" select = "string-length(@component-name) + 2" />							
		</xsl:call-template>			
		
		<!-- print out 'condition' stmt -->
		<xsl:text>condition </xsl:text>
		<xsl:value-of select="following::*[$index]/@label"/>
		<xsl:text>;&#xa;</xsl:text>
		
		<!-- proc next 'following-sibling' 'condition' element -->
		<xsl:call-template name = "write_conditions" >		
			<xsl:with-param name = "index"  select = "$index + 1" />
		</xsl:call-template>
	</xsl:if>
</xsl:template>



<!--
* Name:	write_document_header
*
* Description:
*
*	The template prints out msc doc header
*
-->
<xsl:template name = "write_document_header" >
	<xsl:text>mscdocument </xsl:text>
	<xsl:value-of select="@name"/>
	<xsl:text>;&#xa;</xsl:text>
	<xsl:text>msc </xsl:text>
	<xsl:value-of select="@name"/>
	<xsl:text>;&#xa;</xsl:text>
	<xsl:text>&#xa;</xsl:text>
</xsl:template>



<!--
* Name:	write_document_footer
*
* Description:
*
*	The template prints out msc doc footer
*
-->
<xsl:template name = "write_document_footer" >
	<xsl:text>&#xa;</xsl:text>	
	<xsl:text>endmsc;</xsl:text>
</xsl:template>



<!--
* Name:	write_message
*
* Description:
*
*	The template print out in and out message stmts if next following
*   do element's component name does not match that of current do.
*
-->
<xsl:template name = "write_message" >
<xsl:param name = "msgid" />	
	<xsl:choose>
	
	    <!--if current do has component-name-->
		<xsl:when test = "@component-name">
		
		<xsl:choose>
		 
		 <!-- if next following do element has component-name-->
		 <xsl:when test="following::do[1]/@component-name">
		 
		  <xsl:choose>
		  <!-- if next following do element's component-name is not same as current do -->
		  <xsl:when test = "following::do[1]/@component-name != @component-name ">
		
			
			<xsl:choose>
			   <!-- if current do element's type is 'Start' -->
			   <xsl:when test = "@type = 'Start'" >
					<!-- print out 'out'  msg stmt -->
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					<xsl:text> out </xsl:text>
					<xsl:value-of select = "@name" />							<!-- use current do's name as the message name-->
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in </xsl:text>
					<xsl:value-of select = "@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>

                                    <!-- process next element -->
			         <xsl:apply-templates select = "following::*[1]" >
				      <xsl:with-param name = "msgid" select = "$msgid + 1" /> <!-- inc msg id -->
		             </xsl:apply-templates>	

				</xsl:when>
				
				<!-- if following do element's type is 'End_Point' -->
				<xsl:when test = "following::do[1]/@type = 'End_Point'" >
					<!-- print out 'out'  msg stmt -->
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					<xsl:text>out </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />			<!-- use following do's name as the message name-->
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>
                                     <!-- process next element -->
			         <xsl:apply-templates select = "following::*[1]" >
				      <xsl:with-param name = "msgid" select = "$msgid + 1" /> <!-- inc msg id -->
		                 </xsl:apply-templates>	

				</xsl:when>

                              

				<!-- otherwise print out arbitrary message name -->
				<xsl:otherwise>
				  <xsl:choose>
				   <xsl:when test = "name(following::*[1]) = 'par'">
				    
				       <xsl:text>all: par begin</xsl:text>
                       <xsl:text>;&#xa;</xsl:text>
                                       

					<!-- print out 'out'  msg stmt -->
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					<xsl:text>out m</xsl:text>
					<xsl:value-of select = "$msgid" />		
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in m</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>
                                       <!-- process next element -->
			         <xsl:apply-templates select = "following::*[2]" >
				      <xsl:with-param name = "msgid" select = "$msgid + 1" /> <!-- inc msg id -->
		                 </xsl:apply-templates>	

				 </xsl:when>
                                  			
				 
				 <xsl:otherwise>
				     <!-- print out 'out'  msg stmt -->
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					<xsl:text>out m</xsl:text>
					<xsl:value-of select = "$msgid" />		
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in m</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>
                                      <!-- process next element -->
		          	<xsl:apply-templates select = "following::*[1]" >
				      <xsl:with-param name = "msgid" select = "$msgid + 1" /> <!-- inc msg id -->
		                </xsl:apply-templates>	
			      </xsl:otherwise>
                                  
				</xsl:choose>	  		
			   </xsl:otherwise>
			 </xsl:choose>
                        

						
		  </xsl:when>

		  <xsl:otherwise>
		    <xsl:choose>
		        <xsl:when test = "@type = 'Start'" >
					
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					
					<xsl:text>condition </xsl:text>
					<xsl:text>[</xsl:text>							<!-- use current do's name as the message name-->
					<xsl:value-of select = "@name" />
					<xsl:text>]</xsl:text>
					<xsl:text>;&#xa;</xsl:text>					
					
				</xsl:when>
				
				<!-- if following do element's type is 'End_Point' -->
				<xsl:when test = "following::do[1]/@type = 'End_Point'" >		
					
					<xsl:text>       condition </xsl:text>
					<xsl:text>[</xsl:text>							
					<xsl:value-of select = "following::do[1]/@name" />
					<xsl:text>]</xsl:text>
					<xsl:text>;&#xa;</xsl:text>		
					
				</xsl:when>
			</xsl:choose>
              
			    <!-- process next element -->
			   <xsl:apply-templates select = "following::*[1]" >				
				<xsl:with-param name = "msgid" select = "$msgid" />
			   </xsl:apply-templates>			
		  </xsl:otherwise>
	    </xsl:choose>
       </xsl:when>	
       
        <xsl:otherwise>
         <xsl:choose>
           <!-- if following do element's type is 'End_Point' -->
		   <xsl:when test = "following::do[1]/@type = 'End_Point'" >
					<!-- print out 'out'  msg stmt -->
					<!-- print out component name or white spaces -->			
					<xsl:text>       out </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />			<!-- use following do's name as the message name-->
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:text>Environment</xsl:text>
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:text>Environment</xsl:text>
					<xsl:text>: in </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- process next element -->
			        <xsl:apply-templates select = "following::*[1]" >
				    <xsl:with-param name = "msgid" select = "$msgid + 1" /> <!-- inc msg id -->
			        </xsl:apply-templates>	
					
			</xsl:when>
			
		  <xsl:otherwise>		
			<!-- process next element -->
			<xsl:apply-templates select = "following::*[1]" >				
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:apply-templates>			
		  </xsl:otherwise>
	    </xsl:choose> 
	   </xsl:otherwise> 
	  </xsl:choose>
	 </xsl:when>  
	   
	 
        
        
       <!--if current do has not component-name-->
       <xsl:otherwise>
           <xsl:choose>    
           <!--if following do has component-name-->
           <xsl:when test="following::do[1]/@component-name">
              <xsl:choose>
              <xsl:when test = "@type = 'Start'" >
					<!-- print out 'out'  msg stmt -->
					<xsl:text>Environment</xsl:text>			<!-- print out component name or white spaces -->			
					<xsl:text>: out </xsl:text>						<!-- use current do's name as the message name-->
					<xsl:value-of select ="@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
			 		<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
	     
	                <!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in </xsl:text>
					<xsl:value-of select = "@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:text>Environment</xsl:text>
					<xsl:text>;&#xa;</xsl:text>
			  </xsl:when>
				
			  <!-- if following do element's type is 'End_Point' -->
			  <xsl:when test = "following::do[1]/@type = 'End_Point'" >
					<!-- print out 'out'  msg stmt -->
					<xsl:call-template name = "write_component_name" />			<!-- print out component name or white spaces -->			
					<xsl:text>out </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />			<!-- use following do's name as the message name-->
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> to </xsl:text>
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>;&#xa;</xsl:text>
					
					<!-- print out 'in'  msg stmt -->
					<xsl:value-of select="following::do[1]/@component-name" />
					<xsl:text>: in </xsl:text>
					<xsl:value-of select="following::do[1]/@name" />
					<xsl:text>,</xsl:text>
					<xsl:value-of select = "$msgid" />
					<xsl:text> from </xsl:text>
					<xsl:value-of select="@component-name"/>
					<xsl:text>;&#xa;</xsl:text>	
			 </xsl:when>

			 <!-- otherwise print out arbitrary message name -->
			   <xsl:otherwise>
			      <xsl:apply-templates select = "following::*[1]" >	
			           <xsl:with-param name = "msgid" select = "$msgid" />
			        </xsl:apply-templates>
			  </xsl:otherwise>
			</xsl:choose>
			
		    <!-- process next element --> 
			<xsl:apply-templates select = "following::*[1]" >	
			           <xsl:with-param name = "msgid" select = "$msgid+1" />
			</xsl:apply-templates>
		  </xsl:when>
		   			
		  <xsl:otherwise>
			<!-- process next element -->
			<xsl:apply-templates select = "following::*[1]" >				
				<xsl:with-param name = "msgid" select = "$msgid" />
			</xsl:apply-templates>			
		 </xsl:otherwise>
	   </xsl:choose> 	   
    </xsl:otherwise>     	  				
 </xsl:choose> 
</xsl:template>


<!--
* Name:	write_scenario_header
*
* Description:
*
*	The template recursively print scenario header
*
-->
<xsl:template name = "write_scenario_header" >
	<xsl:text>&#xa;</xsl:text>
	<xsl:text>text 'scenario: </xsl:text>
	<xsl:value-of select="@name"/>
	<xsl:text>';&#xa;</xsl:text>
	<xsl:text>&#xa;</xsl:text>
</xsl:template>



<!--
* Name:	write_whitespaces
*
* Description:
*
*	The template recursively print out the same number
*   of empty space char as the component name
*
-->
<xsl:template name = "write_whitespaces" >
<xsl:param name = "count"  select = "1" />
<xsl:param name = "length" />
	<xsl:if test = "$length >= $count" >
		<xsl:text> </xsl:text>
		<xsl:call-template name = "write_whitespaces" >
			<xsl:with-param name = "count"  select = "$count + 1" />
			<xsl:with-param name = "length" select = "$length" />							
		</xsl:call-template>
	</xsl:if>
</xsl:template>



</xsl:stylesheet>