<!--

Connector messages name generator.
Description: the name of a connector message depends on its context.
			 Define the rules you want to use here.
Comment: normally, a rule would consist of changin the name of the connector message
		  to the concatination of the previous and next messages.


-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xsltc="http://xml.apache.org/xalan/xsltc"
	extension-element-prefixes="xsltc" version="1.0">
<!-- we want to duplicate everything escept connector messages -->
<xsl:include href="UCMExporterXMLDuplicator.xsl"/>

<xsl:template name="messageTemplate" match="message">
<!-- let's say we want to apply this only for connectors -->

	<xsl:if test="@is-connector = 'true'">
		<xsl:choose>
			<xsl:when test="@connector-type = 'simple'">
				<xsl:element name="message" use-attribute-sets="messageAttributeSet">
					<!-- we will only override the name attribute -->
					<xsl:attribute name="name">
						<xsl:call-template name="getSimpleConnectorContextName"/>
					</xsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:when test="@connector-type = 'parallel'">

			<!--
				no context rule is defined for parallel messages.
				for now we just duplicate them.
			-->
			
				<xsl:copy-of select="."/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy-of select="."/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
	
	<!-- none connectors are simply duplicated -->
	<xsl:if test="@is-connector = 'false'">
		<xsl:copy-of select="."/>
	</xsl:if>
	
</xsl:template>


<xsl:template name="getSimpleConnectorContextName">


	<xsl:if test="string-length(preceding::message[1]/@name) > 0">
		<xsl:text>did_</xsl:text>
		<xsl:value-of select="preceding::message[1]/@name"/>
		<xsl:text>_</xsl:text>
	</xsl:if>

	<xsl:if test="string-length(following::message[1]/@name) > 0">
		<xsl:text>do_</xsl:text>
		<xsl:value-of select="following::message[1]/@name"/>
	</xsl:if>


</xsl:template>

</xsl:stylesheet>