<!--

Include this file if you want to duplicate the
UCMExporterXML file you have except for one or more things.

You can define your own templates that will override the ones here.

For example: a message customizer will only define a message template
and maybe a message attribute set to override the existing one if need be.

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xsltc="http://xml.apache.org/xalan/xsltc"
	extension-element-prefixes="xsltc" version="1.0">

<xsl:include href="ElementAttributeSets.xsl"/>

<xsl:template match="/">

	<!-- duplicate scenarios -->
	<xsl:apply-templates select="scenarios"/>

</xsl:template>



<xsl:template name="scenariosTemplate" match="scenarios">

	<xsl:element name="scenarios" use-attribute-sets="scenariosAttributeSet">

		<!-- show the components -->
		<xsl:copy-of select="./components"/>

		<!-- handle each group at a time -->
		<xsl:apply-templates select="./group"/>

	</xsl:element>

</xsl:template>



<xsl:template name = "groupTemplate" match="group">

	<xsl:element name="group" use-attribute-sets="groupAttributeSet">

		<!-- handle each scenario at a time -->
		<xsl:apply-templates select="./scenario"/>

	</xsl:element>

</xsl:template>



<xsl:template name="scenarioTemplate" match="scenario">

	<xsl:element name="scenario" use-attribute-sets="scenarioAttributeSet">

		<!-- copy the instances -->
		<xsl:copy-of select="./instances"/>

		<!-- handle the message sequence -->
		<xsl:apply-templates select="./seq"/>

	</xsl:element>

</xsl:template>


<xsl:template match="seq" name="seqTemplate">
			<xsl:element name="seq" use-attribute-sets="seqAttributeSet">
				<xsl:apply-templates select="child::*"/>
			</xsl:element>
</xsl:template>


<xsl:template match="par" name="parTemplate">
		<xsl:element name="par" use-attribute-sets="parAttributeSet">
			<xsl:apply-templates select="child::*"/>
		</xsl:element>
</xsl:template>

<xsl:template match="do">
	<xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="condition">
	<xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="message">
	<xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="paraMessageConnectors">
	<xsl:copy-of select="."/>
</xsl:template>

</xsl:stylesheet>